blob: 6705b2029975060579540d589fd782d6174ba2f9 [file] [log] [blame]
Andy Baviere4b346e2015-02-06 16:39:06 -05001#!/bin/bash
Siobhan Tully44fd4cc2014-02-23 00:07:12 -05002
3if [ -z "$1" ]; then
Scott Bakerf4db3812014-05-09 16:42:13 -07004 echo usage: $0 "[initdb | createdb | dropdb | syncdb | runserver | resetdb | dumpdata]"
Siobhan Tully44fd4cc2014-02-23 00:07:12 -05005 exit
6fi
7
Scott Baker06116da2015-02-04 21:50:08 -08008XOS_DIR=/opt/xos
9BACKUP_DIR=/opt/xos_backups
Scott Bakerd2ebcd42015-02-19 21:56:58 -080010DBNAME=xos
Scott Bakerb4785022014-05-15 13:22:28 -070011
Scott Baker02451372014-09-16 09:46:35 -070012DJANGO_17=`python -c "import django; from distutils.version import StrictVersion; print int(StrictVersion(django.get_version()) >= StrictVersion('1.7'))"`
13
Scott Bakerdc74f7d2015-02-04 15:04:26 -080014cd $XOS_DIR
Siobhan Tully44fd4cc2014-02-23 00:07:12 -050015
Scott Baker5bec7592015-02-19 11:34:41 -080016function is_ubuntu {
17 if ! which lsb_release &> /dev/null; then
18 # lsb_release is not installed
19 return 1
20 fi
21 if lsb_release -i | grep -i ubuntu &> /dev/null; then
22 return 0
23 fi
24 return 2
25}
26
Scott Bakerb4785022014-05-15 13:22:28 -070027function ensure_postgres_running {
28 # "sudo -u postgres pg_ctl -D /var/lib/postgres/data status" doesn't work
29 # right on Vicci, so let's try to detect it by seeing if the port is
30 # being listened on
31
Scott Baker5bec7592015-02-19 11:34:41 -080032 netstat -nl | grep -i ":5432 " > /dev/null
Scott Bakerb4785022014-05-15 13:22:28 -070033 if [[ $? == 0 ]]; then
34 echo "Postgres is already running"
35 return
36 fi
37
Scott Baker5bec7592015-02-19 11:34:41 -080038 # note that initdb isn't needed in Ubuntu distributions, and calling it
39 # will throw spurious error messages
40 if ! is_ubuntu; then
41 service postgresql initdb
42 fi
Andy Baviere4b346e2015-02-06 16:39:06 -050043 service postgresql start
Scott Bakerb4785022014-05-15 13:22:28 -070044
Scott Baker5bec7592015-02-19 11:34:41 -080045 netstat -nl | grep -i ":5432 " > /dev/null
Scott Bakerb4785022014-05-15 13:22:28 -070046 if [[ $? != 0 ]]; then
Scott Baker5bec7592015-02-19 11:34:41 -080047 # it's still not running...
48 # this is intended for Vicci where some D-Bus issue is
49 # preventing systemctl from working properly.
Scott Bakerb4785022014-05-15 13:22:28 -070050 echo "Trying fallback mechanism to start Postgres"
Siobhan Tully44fd4cc2014-02-23 00:07:12 -050051 sudo -u postgres initdb -D /var/lib/pgsql/data/
52 sudo -u postgres pg_ctl -D /var/lib/pgsql/data -l logfile start
Siobhan Tully44fd4cc2014-02-23 00:07:12 -050053 fi
Scott Bakerb4785022014-05-15 13:22:28 -070054
Siobhan Tully44fd4cc2014-02-23 00:07:12 -050055}
Scott Baker5bec7592015-02-19 11:34:41 -080056
Scott Bakerf8435ca2015-07-20 10:57:08 -070057function wait_postgres {
58 sudo -u postgres psql -c '\q'
59 while [[ "$?" != "0" ]]; do
60 echo Waiting for postgres to start
61 sleep 1
62 sudo -u postgres psql -c '\q'
63 done
64}
65
Scott Baker5bec7592015-02-19 11:34:41 -080066function db_exists {
67 sudo -u postgres psql $DBNAME -c '\q' 2>/dev/null
68 return $?
69}
70
Siobhan Tully44fd4cc2014-02-23 00:07:12 -050071function createdb {
Scott Bakerf8435ca2015-07-20 10:57:08 -070072 wait_postgres
Scott Bakerdc74f7d2015-02-04 15:04:26 -080073 echo "Creating XOS database..."
74 sudo -u postgres createdb $DBNAME
Siobhan Tully44fd4cc2014-02-23 00:07:12 -050075}
76function dropdb {
Scott Bakerdc74f7d2015-02-04 15:04:26 -080077 echo "Dropping XOS database..."
78 sudo -u postgres dropdb $DBNAME
Siobhan Tully44fd4cc2014-02-23 00:07:12 -050079}
80function syncdb {
Scott Bakerdc74f7d2015-02-04 15:04:26 -080081 echo "Syncing XOS services..."
Scott Bakera8b263b2015-02-04 22:47:45 -080082 python $XOS_DIR/manage.py syncdb --noinput
Scott Baker02451372014-09-16 09:46:35 -070083 if [[ $DJANGO_17 ]]; then
84 echo "Loading initial data from fixture..."
Scott Bakera8b263b2015-02-04 22:47:45 -080085 python $XOS_DIR/manage.py --noobserver --nomodelpolicy loaddata $XOS_DIR/core/fixtures/initial_data.json
Scott Baker02451372014-09-16 09:46:35 -070086 fi
Siobhan Tully44fd4cc2014-02-23 00:07:12 -050087}
Scott Baker25b70fd2014-05-15 14:11:58 -070088function evolvedb {
Scott Bakerdc74f7d2015-02-04 15:04:26 -080089 echo "Evolving XOS services..."
Scott Bakera8b263b2015-02-04 22:47:45 -080090 python $XOS_DIR/manage.py evolve --hint --execute --noinput
Scott Baker25b70fd2014-05-15 14:11:58 -070091}
Scott Baker6ecdc422014-09-12 15:10:01 -070092function migratedb {
Scott Bakerdc74f7d2015-02-04 15:04:26 -080093 echo "Migrating XOS services..."
Scott Bakera8b263b2015-02-04 22:47:45 -080094 python $XOS_DIR/manage.py migrate
Scott Baker6ecdc422014-09-12 15:10:01 -070095}
Scott Bakerb4785022014-05-15 13:22:28 -070096function stopserver {
Scott Bakerdc74f7d2015-02-04 15:04:26 -080097 echo "Stopping any running XOS Service(s)"
Scott Bakerb4785022014-05-15 13:22:28 -070098 pkill -f "python.*runserver"
99}
Siobhan Tully44fd4cc2014-02-23 00:07:12 -0500100function runserver {
Andy Baviere4b346e2015-02-06 16:39:06 -0500101 ensure_postgres_running
Scott Bakera8b263b2015-02-04 22:47:45 -0800102 PUBLIC_HOSTNAME=`$XOS_DIR/xos-config.py get server_hostname $HOSTNAME`
Scott Bakerdc74f7d2015-02-04 15:04:26 -0800103 echo "Starting XOS Service on $PUBLIC_HOSTNAME:8000"
Scott Bakere712c792015-02-06 16:26:04 -0800104 python manage.py runserver $PUBLIC_HOSTNAME:8000 --insecure&
Siobhan Tully44fd4cc2014-02-23 00:07:12 -0500105}
106
Scott Bakerf4db3812014-05-09 16:42:13 -0700107function dumpdata {
Scott Bakerb4785022014-05-15 13:22:28 -0700108 mkdir -p $BACKUP_DIR
109 FN="$BACKUP_DIR/dumpdata-`date +%Y-%m-%d_%H:%M:%S`.json"
110 echo "Saving data to $FN"
Scott Bakera2e881c2014-08-15 16:52:55 -0700111 python manage.py dumpdata core hpc syndicate_storage requestrouter -a --indent 4 > $FN
Scott Bakerb4785022014-05-15 13:22:28 -0700112 if [[ ! -f $FN ]]; then
113 echo "FAILED to create $FN"
114 exit
115 fi
Scott Baker25b70fd2014-05-15 14:11:58 -0700116 SIZE=$(du -k "$FN" | cut -f 1)
117 if [[ $SIZE -lt 9 ]]; then
118 echo "Dumpdata was empty. Deleting and aborting"
119 rm $FN
120 exit
121 fi
Scott Bakerb4785022014-05-15 13:22:28 -0700122 rm -f $BACKUP_DIR/dumpdata-latest.json
123 ln -s $FN $BACKUP_DIR/dumpdata-latest.json
Scott Bakerf4db3812014-05-09 16:42:13 -0700124}
125
Sapan Bhatia0e8769f2014-09-08 10:53:53 -0400126function genkeys {
127 mkdir -p public_keys
128 mkdir -p private_keys
129 echo "Generating keys"
130 keyczart create --location=private_keys --name="OpenCloud" --purpose=crypt --asymmetric=rsa
131 keyczart addkey --location=private_keys --status=primary --size=1024
132 keyczart pubkey --location=private_keys --destination=public_keys
133 if [[ ! -f public_keys/1 ]]; then
134 echo "FAILED to create keys"
135 exit
136 fi
137}
138
Scott Baker4d8a6382015-02-18 16:42:14 -0800139function remigrate {
Scott Baker5bec7592015-02-19 11:34:41 -0800140 if db_exists; then
141 dropdb
142 fi
Scott Baker4d8a6382015-02-18 16:42:14 -0800143 rm -rf /opt/xos/*/migrations
144 python ./manage.py makemigrations core
145 python ./manage.py makemigrations hpc
146 python ./manage.py makemigrations requestrouter
147 python ./manage.py makemigrations syndicate_storage
Scott Baker9ff69602015-05-06 12:04:09 -0700148 python ./manage.py makemigrations cord
Scott Baker92a05d72015-09-10 09:02:01 -0700149 python ./manage.py makemigrations ceilometer
Scott Baker4d8a6382015-02-18 16:42:14 -0800150 #python ./manage.py makemigrations servcomp
151}
152
Siobhan Tully44fd4cc2014-02-23 00:07:12 -0500153COMMAND=$1
154
155if [ "$COMMAND" = "initdb" ]; then
Scott Bakerb4785022014-05-15 13:22:28 -0700156 stopserver
157 ensure_postgres_running
158 createdb
159 syncdb
Scott Bakerb4785022014-05-15 13:22:28 -0700160fi
Scott Baker25b70fd2014-05-15 14:11:58 -0700161if [ "$COMMAND" = "repairdb" ]; then
Scott Bakerb4785022014-05-15 13:22:28 -0700162 stopserver
163 ensure_postgres_running
164 dumpdata
Scott Baker25b70fd2014-05-15 14:11:58 -0700165 # TODO: This is where we could run migration scripts to upgrade the
Scott Bakerb4785022014-05-15 13:22:28 -0700166 # dumped data to the new models.
Scott Bakera8b263b2015-02-04 22:47:45 -0800167 mv $XOS_DIR/core/fixtures/initial_data.json $XOS_DIR/core/fixtures/initial_data.json-old
168 cp $BACKUP_DIR/dumpdata-latest.json $XOS_DIR/core/fixtures/initial_data.json
Scott Bakerb4785022014-05-15 13:22:28 -0700169 dropdb
Siobhan Tully44fd4cc2014-02-23 00:07:12 -0500170 createdb
171 syncdb
Scott Baker25b70fd2014-05-15 14:11:58 -0700172fi
173if [ "$COMMAND" = "restoredb" ]; then
174 if [[ ! -f $BACKUP_DIR/dumpdata-latest.json ]]; then
175 echo There is no dumpdata to restore
176 exit
177 fi
178 stopserver
179 ensure_postgres_running
Scott Bakera8b263b2015-02-04 22:47:45 -0800180 mv $XOS_DIR/core/fixtures/initial_data.json $XOS_DIR/core/fixtures/initial_data.json-old
181 cp $BACKUP_DIR/dumpdata-latest.json $XOS_DIR/core/fixtures/initial_data.json
Scott Baker25b70fd2014-05-15 14:11:58 -0700182 dropdb
183 createdb
184 syncdb
185fi
Scott Baker4bb7cbc2014-09-17 22:19:54 -0700186if [ "$COMMAND" = "evolvedb" -o "$COMMAND" = "migratedb" ]; then
Scott Baker25b70fd2014-05-15 14:11:58 -0700187 stopserver
188 ensure_postgres_running
Scott Baker4bb7cbc2014-09-17 22:19:54 -0700189 if [[ $DJANGO_17 ]]; then
190 migratedb
191 else
192 evolvedb
193 fi
Scott Baker6ecdc422014-09-12 15:10:01 -0700194fi
Siobhan Tully44fd4cc2014-02-23 00:07:12 -0500195if [ "$COMMAND" = "resetdb" ]; then
Scott Bakerb4785022014-05-15 13:22:28 -0700196 stopserver
S.Çağlar Onur995e07d2015-02-24 15:34:39 -0500197 ensure_postgres_running
Siobhan Tully44fd4cc2014-02-23 00:07:12 -0500198 dropdb
199 createdb
200 syncdb
Siobhan Tully44fd4cc2014-02-23 00:07:12 -0500201fi
202if [ "$COMMAND" = "syncdb" ]; then
Scott Bakerb4785022014-05-15 13:22:28 -0700203 stopserver
Siobhan Tully44fd4cc2014-02-23 00:07:12 -0500204 syncdb
Siobhan Tully44fd4cc2014-02-23 00:07:12 -0500205fi
206if [ "$COMMAND" = "runserver" ]; then
Scott Bakerb4785022014-05-15 13:22:28 -0700207 stopserver
Siobhan Tully44fd4cc2014-02-23 00:07:12 -0500208 runserver
209fi
Scott Bakerb4785022014-05-15 13:22:28 -0700210if [ "$COMMAND" = "stopserver" ]; then
211 stopserver
212fi
Scott Bakerf4db3812014-05-09 16:42:13 -0700213if [ "$COMMAND" = "dumpdata" ]; then
214 dumpdata
215fi
Sapan Bhatia0e8769f2014-09-08 10:53:53 -0400216if [ "$COMMAND" = "genkeys" ]; then
217 genkeys
218fi
Scott Bakerc57ddcc2015-02-16 23:34:48 -0800219if [ "$COMMAND" = "generateapi" ]; then
Scott Bakercd4a0c22015-02-16 23:47:11 -0800220 python apigen/modelgen apigen/api.template.py > xos/xosapi.py
Scott Baker4d8a6382015-02-18 16:42:14 -0800221fi
222if [ "$COMMAND" = "remigrate" ]; then
223 ensure_postgres_running
224 remigrate
225 createdb
226 syncdb
S.Çağlar Onur995e07d2015-02-24 15:34:39 -0500227fi